local assets =
{ 
    Asset("ANIM", "anim/hat_police_swap.zip"),
	Asset("ANIM", "anim/hat_police.zip"),

    Asset("ATLAS", "images/inventoryimages/policehat.xml"),
    Asset("IMAGE", "images/inventoryimages/policehat.tex"),
}

local prefabs = 
{
}

local function OnEquip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_hat", "hat_police_swap", "swap_hat")
	
    owner.AnimState:Show("HAT")
    owner.AnimState:Show("HAT_HAIR")
	
	owner:AddTag("beefalo")
	
    if owner:HasTag("player") then
        owner.AnimState:Hide("HEAD")
        owner.AnimState:Show("HEAD_HAT")	
    end
	if inst.components.fueled ~= nil then
       inst.components.fueled:StartConsuming()
    end
end

local function OnUnequip(inst, owner) 

    owner.AnimState:Hide("HAT")
    owner.AnimState:Hide("HAT_HAIR")

	owner:RemoveTag("beefalo")
	
    if owner:HasTag("player") then
        owner.AnimState:Show("HEAD")
        owner.AnimState:Hide("HEAD_HAT")
		
    end
	if inst.components.fueled ~= nil then
       inst.components.fueled:StopConsuming()
    end
end

local function fn()

    local inst = CreateEntity()
    
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	
	inst.entity:AddSoundEmitter()
	
    inst.entity:AddNetwork()
	
    MakeInventoryPhysics(inst)
	
    inst.AnimState:SetBank("hat_miner")
    inst.AnimState:SetBuild("hat_police")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("hat")
	inst:AddTag("waterproofer")

    if not TheWorld.ismastersim then
        return inst
    end
	
	
    inst.entity:SetPristine()
	
    inst:AddComponent("inspectable")
	

    inst:AddComponent("tradable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "policehat"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/policehat.xml"
	
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable:SetOnEquip(OnEquip)
    inst.components.equippable:SetOnUnequip(OnUnequip)
	inst.components.equippable.dapperness = 0.05
	
	inst:AddComponent("armor")
    inst.components.armor:InitCondition(TUNING.ARMORWOOD, TUNING.ARMORWOOD_ABSORPTION)
	
	inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(4)
	
	inst:AddComponent("insulator")
	inst.components.insulator:SetSummer()
    inst.components.insulator:SetInsulation(30)

    MakeHauntableLaunch(inst)

    return inst
end

STRINGS.NAMES.POLICEHAT = "Police hat"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.POLICEHAT = "Looks very official"
STRINGS.RECIPE_DESC.POLICEHAT = "Helps you reassure the law"

return  Prefab("common/inventory/policehat", fn, assets, prefabs)